----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:26:45 09/25/2013 
-- Design Name: 
-- Module Name:    chipscope - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity chipscope1 is
		generic (N : integer := 5);
    Port ( clk : in  STD_LOGIC;
           Din : in  STD_LOGIC_VECTOR (303 downto 0));
end chipscope1;

architecture Behavioral of chipscope1 is
component ila288x4096
  PORT (
    CONTROL : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CLK : IN STD_LOGIC;
    DATA : IN STD_LOGIC_VECTOR(287 DOWNTO 0);
    TRIG0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    TRIG1 : IN STD_LOGIC_VECTOR(7 DOWNTO 0));

end component;
component icon1
  PORT (
    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0));
end component;
signal DATAa : std_logic_vector(287 downto 0);
signal RDADDRa : std_logic_vector(8 downto 0) := (others => '0');
signal WRADDRa : std_logic_vector(8 downto 0) := (others => '0');
signal CONTROL0 : std_logic_vector(35 downto 0);
signal DIa : std_logic_vector(287 downto 0);
begin
i_icon : icon1
  port map (
    CONTROL0 => CONTROL0);
i_ila : ila288x4096
  port map (
    CONTROL => CONTROL0,
    CLK => CLK,
    DATA => DATAa,
    TRIG0 => Din(295 downto 288),
    TRIG1 => Din(303 downto 296));
g_delaya : for i in 0 to 3 generate
	i_delaya : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "7SERIES", "VIRTEX6, "SPARTAN6" 
      WRITE_WIDTH => 72,   -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 72)   -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
   port map (
      DO => DATAa(72*i+71 downto 72*i),         -- Output read data port, width defined by READ_WIDTH parameter
      DI => Din(72*i+71 downto 72*i),         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => RDADDRa, -- Input read address, width defined by read port depth
      RDCLK => clk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"ff",         -- Input write enable, width defined by write port depth
      WRADDR => WRADDRa, -- Input write address, width defined by write port depth
      WRCLK => clk,   -- 1-bit input write clock
      WREN => '1'      -- 1-bit input write port enable
   );
end generate;
process(clk)
begin
	if(clk'event and clk = '1')then
		RDADDRa(N downto 0) <= RDADDRa(N downto 0) + 1;
		WRADDRa <= RDADDRa;
		DIa <= Din(287 downto 0);
	end if;
end process;
end Behavioral;

