-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 2.5
--  \   \         Application : 7 Series FPGAs Transceivers Wizard
--  /   /         Filename : amc_gtxv.vhd
-- /___/   /\     
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module AMC_GTXv (a Core Top)
-- Generated by Xilinx 7 Series FPGAs Transceivers Wizard
-- 
-- 
-- (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***************************** Entity Declaration ****************************
entity AMC_GTXv is
generic
(
    QPLL_FBDIV_TOP                  : integer  := 40;

    -- Simulation attributes
    WRAPPER_SIM_GTRESET_SPEEDUP     : string     :=  "FALSE";        -- Set to "true" to speed up sim reset
    RX_DFE_KL_CFG2_IN               : bit_vector :=  X"3010D90C";
    PMA_RSV_IN                      : bit_vector :=  x"001E7080"
);
port
(
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X0Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    GT0_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT0_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT1  (X0Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    GT1_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT1_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT2  (X0Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    GT2_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT2_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT3  (X0Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    GT3_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT3_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT3_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT4  (X0Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    GT4_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT4_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT4_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT5  (X0Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    GT5_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT5_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT5_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT6  (X0Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    GT6_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT6_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT6_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT7  (X0Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    GT7_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT7_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT7_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT8  (X0Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    GT8_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT8_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT8_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT9  (X0Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    GT9_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT9_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT9_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT10  (X0Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFEAGCHOLD_IN                    : in   std_logic;
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    GT10_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT10_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT10_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);

    --GT11  (X0Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFEAGCHOLD_IN                    : in   std_logic;
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    GT11_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT11_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT11_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);


    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic

);
end AMC_GTXv;

architecture RTL of AMC_GTXv is
--**************************Component Declarations*****************************
component AMC_GTXv_multi_gt 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTRESET_SPEEDUP    : string    := "FALSE" -- Set to 1 to speed up sim reset
);
port
(
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X0Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    GT0_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT0_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT1  (X0Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    GT1_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT1_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT2  (X0Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    GT2_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT2_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT3  (X0Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    GT3_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT3_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT3_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT4  (X0Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    GT4_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT4_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT4_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT5  (X0Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    GT5_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT5_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT5_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT6  (X0Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    GT6_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT6_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT6_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT7  (X0Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    GT7_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT7_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT7_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT8  (X0Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    GT8_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT8_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT8_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT9  (X0Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFEAGCHOLD_IN                     : in   std_logic;
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    GT9_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT9_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT9_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT10  (X0Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFEAGCHOLD_IN                    : in   std_logic;
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    GT10_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT10_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT10_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT11  (X0Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFEAGCHOLD_IN                    : in   std_logic;
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    GT11_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT11_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT11_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic

);
end component;

--**************************** Main Body of Code *******************************
begin
    U0 : AMC_GTXv_multi_gt
    generic map
    (
        WRAPPER_SIM_GTRESET_SPEEDUP     =>      WRAPPER_SIM_GTRESET_SPEEDUP
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X0Y0)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  =>      GT0_DRPADDR_IN,
        GT0_DRPCLK_IN                   =>      GT0_DRPCLK_IN,
        GT0_DRPDI_IN                    =>      GT0_DRPDI_IN,
        GT0_DRPDO_OUT                   =>      GT0_DRPDO_OUT,
        GT0_DRPEN_IN                    =>      GT0_DRPEN_IN,
        GT0_DRPRDY_OUT                  =>      GT0_DRPRDY_OUT,
        GT0_DRPWE_IN                    =>      GT0_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 =>      GT0_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                =>      GT0_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        =>      GT0_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      GT0_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT0_RXCLKCORCNT_OUT             =>      GT0_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 =>      GT0_RXUSRCLK_IN,
        GT0_RXUSRCLK2_IN                =>      GT0_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  =>      GT0_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               =>      GT0_RXPRBSERR_OUT,
        GT0_RXPRBSSEL_IN                =>      GT0_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      GT0_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT0_RXDISPERR_OUT               =>      GT0_RXDISPERR_OUT,
        GT0_RXNOTINTABLE_OUT            =>      GT0_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   =>      GT0_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   =>      GT0_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT0_RXMCOMMAALIGNEN_IN          =>      GT0_RXMCOMMAALIGNEN_IN,
        GT0_RXPCOMMAALIGNEN_IN          =>      GT0_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT0_RXDFEAGCHOLD_IN             =>      GT0_RXDFEAGCHOLD_IN,
        GT0_RXDFELPMRESET_IN            =>      GT0_RXDFELPMRESET_IN,
        GT0_RXMONITOROUT_OUT            =>      GT0_RXMONITOROUT_OUT,
        GT0_RXMONITORSEL_IN             =>      GT0_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT0_RXOUTCLK_OUT                =>      GT0_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                =>      GT0_GTRXRESET_IN,
        GT0_RXPMARESET_IN               =>      GT0_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT0_RXCHARISCOMMA_OUT           =>      GT0_RXCHARISCOMMA_OUT,
        GT0_RXCHARISK_OUT               =>      GT0_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             =>      GT0_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                =>      GT0_GTTXRESET_IN,
        GT0_TXUSERRDY_IN                =>      GT0_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 =>      GT0_TXUSRCLK_IN,
        GT0_TXUSRCLK2_IN                =>      GT0_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               =>      GT0_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   =>      GT0_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  =>      GT0_GTXTXN_OUT,
        GT0_GTXTXP_OUT                  =>      GT0_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                =>      GT0_TXOUTCLK_OUT,
        GT0_TXOUTCLKFABRIC_OUT          =>      GT0_TXOUTCLKFABRIC_OUT,
        GT0_TXOUTCLKPCS_OUT             =>      GT0_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXCHARISK_IN                =>      GT0_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             =>      GT0_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                =>      GT0_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X0Y1)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  =>      GT1_DRPADDR_IN,
        GT1_DRPCLK_IN                   =>      GT1_DRPCLK_IN,
        GT1_DRPDI_IN                    =>      GT1_DRPDI_IN,
        GT1_DRPDO_OUT                   =>      GT1_DRPDO_OUT,
        GT1_DRPEN_IN                    =>      GT1_DRPEN_IN,
        GT1_DRPRDY_OUT                  =>      GT1_DRPRDY_OUT,
        GT1_DRPWE_IN                    =>      GT1_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 =>      GT1_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                =>      GT1_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        =>      GT1_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      GT1_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT1_RXCLKCORCNT_OUT             =>      GT1_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 =>      GT1_RXUSRCLK_IN,
        GT1_RXUSRCLK2_IN                =>      GT1_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  =>      GT1_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               =>      GT1_RXPRBSERR_OUT,
        GT1_RXPRBSSEL_IN                =>      GT1_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      GT1_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT1_RXDISPERR_OUT               =>      GT1_RXDISPERR_OUT,
        GT1_RXNOTINTABLE_OUT            =>      GT1_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   =>      GT1_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   =>      GT1_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT1_RXMCOMMAALIGNEN_IN          =>      GT1_RXMCOMMAALIGNEN_IN,
        GT1_RXPCOMMAALIGNEN_IN          =>      GT1_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT1_RXDFEAGCHOLD_IN             =>      GT1_RXDFEAGCHOLD_IN,
        GT1_RXDFELPMRESET_IN            =>      GT1_RXDFELPMRESET_IN,
        GT1_RXMONITOROUT_OUT            =>      GT1_RXMONITOROUT_OUT,
        GT1_RXMONITORSEL_IN             =>      GT1_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT1_RXOUTCLK_OUT                =>      GT1_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                =>      GT1_GTRXRESET_IN,
        GT1_RXPMARESET_IN               =>      GT1_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT1_RXCHARISCOMMA_OUT           =>      GT1_RXCHARISCOMMA_OUT,
        GT1_RXCHARISK_OUT               =>      GT1_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             =>      GT1_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                =>      GT1_GTTXRESET_IN,
        GT1_TXUSERRDY_IN                =>      GT1_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 =>      GT1_TXUSRCLK_IN,
        GT1_TXUSRCLK2_IN                =>      GT1_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               =>      GT1_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   =>      GT1_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  =>      GT1_GTXTXN_OUT,
        GT1_GTXTXP_OUT                  =>      GT1_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                =>      GT1_TXOUTCLK_OUT,
        GT1_TXOUTCLKFABRIC_OUT          =>      GT1_TXOUTCLKFABRIC_OUT,
        GT1_TXOUTCLKPCS_OUT             =>      GT1_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXCHARISK_IN                =>      GT1_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             =>      GT1_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                =>      GT1_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X0Y2)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  =>      GT2_DRPADDR_IN,
        GT2_DRPCLK_IN                   =>      GT2_DRPCLK_IN,
        GT2_DRPDI_IN                    =>      GT2_DRPDI_IN,
        GT2_DRPDO_OUT                   =>      GT2_DRPDO_OUT,
        GT2_DRPEN_IN                    =>      GT2_DRPEN_IN,
        GT2_DRPRDY_OUT                  =>      GT2_DRPRDY_OUT,
        GT2_DRPWE_IN                    =>      GT2_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 =>      GT2_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                =>      GT2_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        =>      GT2_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      GT2_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT2_RXCLKCORCNT_OUT             =>      GT2_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 =>      GT2_RXUSRCLK_IN,
        GT2_RXUSRCLK2_IN                =>      GT2_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  =>      GT2_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               =>      GT2_RXPRBSERR_OUT,
        GT2_RXPRBSSEL_IN                =>      GT2_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      GT2_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT2_RXDISPERR_OUT               =>      GT2_RXDISPERR_OUT,
        GT2_RXNOTINTABLE_OUT            =>      GT2_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   =>      GT2_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   =>      GT2_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT2_RXMCOMMAALIGNEN_IN          =>      GT2_RXMCOMMAALIGNEN_IN,
        GT2_RXPCOMMAALIGNEN_IN          =>      GT2_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT2_RXDFEAGCHOLD_IN             =>      GT2_RXDFEAGCHOLD_IN,
        GT2_RXDFELPMRESET_IN            =>      GT2_RXDFELPMRESET_IN,
        GT2_RXMONITOROUT_OUT            =>      GT2_RXMONITOROUT_OUT,
        GT2_RXMONITORSEL_IN             =>      GT2_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT2_RXOUTCLK_OUT                =>      GT2_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                =>      GT2_GTRXRESET_IN,
        GT2_RXPMARESET_IN               =>      GT2_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT2_RXCHARISCOMMA_OUT           =>      GT2_RXCHARISCOMMA_OUT,
        GT2_RXCHARISK_OUT               =>      GT2_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             =>      GT2_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                =>      GT2_GTTXRESET_IN,
        GT2_TXUSERRDY_IN                =>      GT2_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 =>      GT2_TXUSRCLK_IN,
        GT2_TXUSRCLK2_IN                =>      GT2_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               =>      GT2_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   =>      GT2_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  =>      GT2_GTXTXN_OUT,
        GT2_GTXTXP_OUT                  =>      GT2_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                =>      GT2_TXOUTCLK_OUT,
        GT2_TXOUTCLKFABRIC_OUT          =>      GT2_TXOUTCLKFABRIC_OUT,
        GT2_TXOUTCLKPCS_OUT             =>      GT2_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXCHARISK_IN                =>      GT2_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             =>      GT2_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                =>      GT2_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT3  (X0Y3)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT3_DRPADDR_IN                  =>      GT3_DRPADDR_IN,
        GT3_DRPCLK_IN                   =>      GT3_DRPCLK_IN,
        GT3_DRPDI_IN                    =>      GT3_DRPDI_IN,
        GT3_DRPDO_OUT                   =>      GT3_DRPDO_OUT,
        GT3_DRPEN_IN                    =>      GT3_DRPEN_IN,
        GT3_DRPRDY_OUT                  =>      GT3_DRPRDY_OUT,
        GT3_DRPWE_IN                    =>      GT3_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT3_LOOPBACK_IN                 =>      GT3_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT3_RXUSERRDY_IN                =>      GT3_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT3_EYESCANDATAERROR_OUT        =>      GT3_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT3_RXCDRLOCK_OUT               =>      GT3_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT3_RXCLKCORCNT_OUT             =>      GT3_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT3_RXUSRCLK_IN                 =>      GT3_RXUSRCLK_IN,
        GT3_RXUSRCLK2_IN                =>      GT3_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT3_RXDATA_OUT                  =>      GT3_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT3_RXPRBSERR_OUT               =>      GT3_RXPRBSERR_OUT,
        GT3_RXPRBSSEL_IN                =>      GT3_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT3_RXPRBSCNTRESET_IN           =>      GT3_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT3_RXDISPERR_OUT               =>      GT3_RXDISPERR_OUT,
        GT3_RXNOTINTABLE_OUT            =>      GT3_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT3_GTXRXP_IN                   =>      GT3_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT3_GTXRXN_IN                   =>      GT3_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT3_RXMCOMMAALIGNEN_IN          =>      GT3_RXMCOMMAALIGNEN_IN,
        GT3_RXPCOMMAALIGNEN_IN          =>      GT3_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT3_RXDFEAGCHOLD_IN             =>      GT3_RXDFEAGCHOLD_IN,
        GT3_RXDFELPMRESET_IN            =>      GT3_RXDFELPMRESET_IN,
        GT3_RXMONITOROUT_OUT            =>      GT3_RXMONITOROUT_OUT,
        GT3_RXMONITORSEL_IN             =>      GT3_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT3_RXOUTCLK_OUT                =>      GT3_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT3_GTRXRESET_IN                =>      GT3_GTRXRESET_IN,
        GT3_RXPMARESET_IN               =>      GT3_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT3_RXCHARISCOMMA_OUT           =>      GT3_RXCHARISCOMMA_OUT,
        GT3_RXCHARISK_OUT               =>      GT3_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT3_RXRESETDONE_OUT             =>      GT3_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT3_GTTXRESET_IN                =>      GT3_GTTXRESET_IN,
        GT3_TXUSERRDY_IN                =>      GT3_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT3_TXUSRCLK_IN                 =>      GT3_TXUSRCLK_IN,
        GT3_TXUSRCLK2_IN                =>      GT3_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT3_TXDIFFCTRL_IN               =>      GT3_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT3_TXDATA_IN                   =>      GT3_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT3_GTXTXN_OUT                  =>      GT3_GTXTXN_OUT,
        GT3_GTXTXP_OUT                  =>      GT3_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT3_TXOUTCLK_OUT                =>      GT3_TXOUTCLK_OUT,
        GT3_TXOUTCLKFABRIC_OUT          =>      GT3_TXOUTCLKFABRIC_OUT,
        GT3_TXOUTCLKPCS_OUT             =>      GT3_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT3_TXCHARISK_IN                =>      GT3_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT3_TXRESETDONE_OUT             =>      GT3_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT3_TXPRBSSEL_IN                =>      GT3_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT4  (X0Y4)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT4_DRPADDR_IN                  =>      GT4_DRPADDR_IN,
        GT4_DRPCLK_IN                   =>      GT4_DRPCLK_IN,
        GT4_DRPDI_IN                    =>      GT4_DRPDI_IN,
        GT4_DRPDO_OUT                   =>      GT4_DRPDO_OUT,
        GT4_DRPEN_IN                    =>      GT4_DRPEN_IN,
        GT4_DRPRDY_OUT                  =>      GT4_DRPRDY_OUT,
        GT4_DRPWE_IN                    =>      GT4_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT4_LOOPBACK_IN                 =>      GT4_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT4_RXUSERRDY_IN                =>      GT4_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT4_EYESCANDATAERROR_OUT        =>      GT4_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT4_RXCDRLOCK_OUT               =>      GT4_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT4_RXCLKCORCNT_OUT             =>      GT4_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT4_RXUSRCLK_IN                 =>      GT4_RXUSRCLK_IN,
        GT4_RXUSRCLK2_IN                =>      GT4_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT4_RXDATA_OUT                  =>      GT4_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT4_RXPRBSERR_OUT               =>      GT4_RXPRBSERR_OUT,
        GT4_RXPRBSSEL_IN                =>      GT4_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT4_RXPRBSCNTRESET_IN           =>      GT4_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT4_RXDISPERR_OUT               =>      GT4_RXDISPERR_OUT,
        GT4_RXNOTINTABLE_OUT            =>      GT4_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT4_GTXRXP_IN                   =>      GT4_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT4_GTXRXN_IN                   =>      GT4_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT4_RXMCOMMAALIGNEN_IN          =>      GT4_RXMCOMMAALIGNEN_IN,
        GT4_RXPCOMMAALIGNEN_IN          =>      GT4_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT4_RXDFEAGCHOLD_IN             =>      GT4_RXDFEAGCHOLD_IN,
        GT4_RXDFELPMRESET_IN            =>      GT4_RXDFELPMRESET_IN,
        GT4_RXMONITOROUT_OUT            =>      GT4_RXMONITOROUT_OUT,
        GT4_RXMONITORSEL_IN             =>      GT4_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT4_RXOUTCLK_OUT                =>      GT4_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT4_GTRXRESET_IN                =>      GT4_GTRXRESET_IN,
        GT4_RXPMARESET_IN               =>      GT4_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT4_RXCHARISCOMMA_OUT           =>      GT4_RXCHARISCOMMA_OUT,
        GT4_RXCHARISK_OUT               =>      GT4_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT4_RXRESETDONE_OUT             =>      GT4_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT4_GTTXRESET_IN                =>      GT4_GTTXRESET_IN,
        GT4_TXUSERRDY_IN                =>      GT4_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT4_TXUSRCLK_IN                 =>      GT4_TXUSRCLK_IN,
        GT4_TXUSRCLK2_IN                =>      GT4_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT4_TXDIFFCTRL_IN               =>      GT4_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT4_TXDATA_IN                   =>      GT4_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT4_GTXTXN_OUT                  =>      GT4_GTXTXN_OUT,
        GT4_GTXTXP_OUT                  =>      GT4_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT4_TXOUTCLK_OUT                =>      GT4_TXOUTCLK_OUT,
        GT4_TXOUTCLKFABRIC_OUT          =>      GT4_TXOUTCLKFABRIC_OUT,
        GT4_TXOUTCLKPCS_OUT             =>      GT4_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT4_TXCHARISK_IN                =>      GT4_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT4_TXRESETDONE_OUT             =>      GT4_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT4_TXPRBSSEL_IN                =>      GT4_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT5  (X0Y5)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT5_DRPADDR_IN                  =>      GT5_DRPADDR_IN,
        GT5_DRPCLK_IN                   =>      GT5_DRPCLK_IN,
        GT5_DRPDI_IN                    =>      GT5_DRPDI_IN,
        GT5_DRPDO_OUT                   =>      GT5_DRPDO_OUT,
        GT5_DRPEN_IN                    =>      GT5_DRPEN_IN,
        GT5_DRPRDY_OUT                  =>      GT5_DRPRDY_OUT,
        GT5_DRPWE_IN                    =>      GT5_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT5_LOOPBACK_IN                 =>      GT5_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT5_RXUSERRDY_IN                =>      GT5_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT5_EYESCANDATAERROR_OUT        =>      GT5_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT5_RXCDRLOCK_OUT               =>      GT5_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT5_RXCLKCORCNT_OUT             =>      GT5_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT5_RXUSRCLK_IN                 =>      GT5_RXUSRCLK_IN,
        GT5_RXUSRCLK2_IN                =>      GT5_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT5_RXDATA_OUT                  =>      GT5_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT5_RXPRBSERR_OUT               =>      GT5_RXPRBSERR_OUT,
        GT5_RXPRBSSEL_IN                =>      GT5_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT5_RXPRBSCNTRESET_IN           =>      GT5_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT5_RXDISPERR_OUT               =>      GT5_RXDISPERR_OUT,
        GT5_RXNOTINTABLE_OUT            =>      GT5_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT5_GTXRXP_IN                   =>      GT5_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT5_GTXRXN_IN                   =>      GT5_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT5_RXMCOMMAALIGNEN_IN          =>      GT5_RXMCOMMAALIGNEN_IN,
        GT5_RXPCOMMAALIGNEN_IN          =>      GT5_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT5_RXDFEAGCHOLD_IN             =>      GT5_RXDFEAGCHOLD_IN,
        GT5_RXDFELPMRESET_IN            =>      GT5_RXDFELPMRESET_IN,
        GT5_RXMONITOROUT_OUT            =>      GT5_RXMONITOROUT_OUT,
        GT5_RXMONITORSEL_IN             =>      GT5_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT5_RXOUTCLK_OUT                =>      GT5_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT5_GTRXRESET_IN                =>      GT5_GTRXRESET_IN,
        GT5_RXPMARESET_IN               =>      GT5_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT5_RXCHARISCOMMA_OUT           =>      GT5_RXCHARISCOMMA_OUT,
        GT5_RXCHARISK_OUT               =>      GT5_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT5_RXRESETDONE_OUT             =>      GT5_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT5_GTTXRESET_IN                =>      GT5_GTTXRESET_IN,
        GT5_TXUSERRDY_IN                =>      GT5_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT5_TXUSRCLK_IN                 =>      GT5_TXUSRCLK_IN,
        GT5_TXUSRCLK2_IN                =>      GT5_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT5_TXDIFFCTRL_IN               =>      GT5_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT5_TXDATA_IN                   =>      GT5_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT5_GTXTXN_OUT                  =>      GT5_GTXTXN_OUT,
        GT5_GTXTXP_OUT                  =>      GT5_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT5_TXOUTCLK_OUT                =>      GT5_TXOUTCLK_OUT,
        GT5_TXOUTCLKFABRIC_OUT          =>      GT5_TXOUTCLKFABRIC_OUT,
        GT5_TXOUTCLKPCS_OUT             =>      GT5_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT5_TXCHARISK_IN                =>      GT5_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT5_TXRESETDONE_OUT             =>      GT5_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT5_TXPRBSSEL_IN                =>      GT5_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT6  (X0Y6)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT6_DRPADDR_IN                  =>      GT6_DRPADDR_IN,
        GT6_DRPCLK_IN                   =>      GT6_DRPCLK_IN,
        GT6_DRPDI_IN                    =>      GT6_DRPDI_IN,
        GT6_DRPDO_OUT                   =>      GT6_DRPDO_OUT,
        GT6_DRPEN_IN                    =>      GT6_DRPEN_IN,
        GT6_DRPRDY_OUT                  =>      GT6_DRPRDY_OUT,
        GT6_DRPWE_IN                    =>      GT6_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT6_LOOPBACK_IN                 =>      GT6_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT6_RXUSERRDY_IN                =>      GT6_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT6_EYESCANDATAERROR_OUT        =>      GT6_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT6_RXCDRLOCK_OUT               =>      GT6_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT6_RXCLKCORCNT_OUT             =>      GT6_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT6_RXUSRCLK_IN                 =>      GT6_RXUSRCLK_IN,
        GT6_RXUSRCLK2_IN                =>      GT6_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT6_RXDATA_OUT                  =>      GT6_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT6_RXPRBSERR_OUT               =>      GT6_RXPRBSERR_OUT,
        GT6_RXPRBSSEL_IN                =>      GT6_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT6_RXPRBSCNTRESET_IN           =>      GT6_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT6_RXDISPERR_OUT               =>      GT6_RXDISPERR_OUT,
        GT6_RXNOTINTABLE_OUT            =>      GT6_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT6_GTXRXP_IN                   =>      GT6_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT6_GTXRXN_IN                   =>      GT6_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT6_RXMCOMMAALIGNEN_IN          =>      GT6_RXMCOMMAALIGNEN_IN,
        GT6_RXPCOMMAALIGNEN_IN          =>      GT6_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT6_RXDFEAGCHOLD_IN             =>      GT6_RXDFEAGCHOLD_IN,
        GT6_RXDFELPMRESET_IN            =>      GT6_RXDFELPMRESET_IN,
        GT6_RXMONITOROUT_OUT            =>      GT6_RXMONITOROUT_OUT,
        GT6_RXMONITORSEL_IN             =>      GT6_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT6_RXOUTCLK_OUT                =>      GT6_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT6_GTRXRESET_IN                =>      GT6_GTRXRESET_IN,
        GT6_RXPMARESET_IN               =>      GT6_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT6_RXCHARISCOMMA_OUT           =>      GT6_RXCHARISCOMMA_OUT,
        GT6_RXCHARISK_OUT               =>      GT6_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT6_RXRESETDONE_OUT             =>      GT6_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT6_GTTXRESET_IN                =>      GT6_GTTXRESET_IN,
        GT6_TXUSERRDY_IN                =>      GT6_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT6_TXUSRCLK_IN                 =>      GT6_TXUSRCLK_IN,
        GT6_TXUSRCLK2_IN                =>      GT6_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT6_TXDIFFCTRL_IN               =>      GT6_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT6_TXDATA_IN                   =>      GT6_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT6_GTXTXN_OUT                  =>      GT6_GTXTXN_OUT,
        GT6_GTXTXP_OUT                  =>      GT6_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT6_TXOUTCLK_OUT                =>      GT6_TXOUTCLK_OUT,
        GT6_TXOUTCLKFABRIC_OUT          =>      GT6_TXOUTCLKFABRIC_OUT,
        GT6_TXOUTCLKPCS_OUT             =>      GT6_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT6_TXCHARISK_IN                =>      GT6_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT6_TXRESETDONE_OUT             =>      GT6_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT6_TXPRBSSEL_IN                =>      GT6_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT7  (X0Y7)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT7_DRPADDR_IN                  =>      GT7_DRPADDR_IN,
        GT7_DRPCLK_IN                   =>      GT7_DRPCLK_IN,
        GT7_DRPDI_IN                    =>      GT7_DRPDI_IN,
        GT7_DRPDO_OUT                   =>      GT7_DRPDO_OUT,
        GT7_DRPEN_IN                    =>      GT7_DRPEN_IN,
        GT7_DRPRDY_OUT                  =>      GT7_DRPRDY_OUT,
        GT7_DRPWE_IN                    =>      GT7_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT7_LOOPBACK_IN                 =>      GT7_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT7_RXUSERRDY_IN                =>      GT7_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT7_EYESCANDATAERROR_OUT        =>      GT7_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT7_RXCDRLOCK_OUT               =>      GT7_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT7_RXCLKCORCNT_OUT             =>      GT7_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT7_RXUSRCLK_IN                 =>      GT7_RXUSRCLK_IN,
        GT7_RXUSRCLK2_IN                =>      GT7_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT7_RXDATA_OUT                  =>      GT7_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT7_RXPRBSERR_OUT               =>      GT7_RXPRBSERR_OUT,
        GT7_RXPRBSSEL_IN                =>      GT7_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT7_RXPRBSCNTRESET_IN           =>      GT7_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT7_RXDISPERR_OUT               =>      GT7_RXDISPERR_OUT,
        GT7_RXNOTINTABLE_OUT            =>      GT7_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT7_GTXRXP_IN                   =>      GT7_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT7_GTXRXN_IN                   =>      GT7_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT7_RXMCOMMAALIGNEN_IN          =>      GT7_RXMCOMMAALIGNEN_IN,
        GT7_RXPCOMMAALIGNEN_IN          =>      GT7_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT7_RXDFEAGCHOLD_IN             =>      GT7_RXDFEAGCHOLD_IN,
        GT7_RXDFELPMRESET_IN            =>      GT7_RXDFELPMRESET_IN,
        GT7_RXMONITOROUT_OUT            =>      GT7_RXMONITOROUT_OUT,
        GT7_RXMONITORSEL_IN             =>      GT7_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT7_RXOUTCLK_OUT                =>      GT7_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT7_GTRXRESET_IN                =>      GT7_GTRXRESET_IN,
        GT7_RXPMARESET_IN               =>      GT7_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT7_RXCHARISCOMMA_OUT           =>      GT7_RXCHARISCOMMA_OUT,
        GT7_RXCHARISK_OUT               =>      GT7_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT7_RXRESETDONE_OUT             =>      GT7_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT7_GTTXRESET_IN                =>      GT7_GTTXRESET_IN,
        GT7_TXUSERRDY_IN                =>      GT7_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT7_TXUSRCLK_IN                 =>      GT7_TXUSRCLK_IN,
        GT7_TXUSRCLK2_IN                =>      GT7_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT7_TXDIFFCTRL_IN               =>      GT7_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT7_TXDATA_IN                   =>      GT7_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT7_GTXTXN_OUT                  =>      GT7_GTXTXN_OUT,
        GT7_GTXTXP_OUT                  =>      GT7_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT7_TXOUTCLK_OUT                =>      GT7_TXOUTCLK_OUT,
        GT7_TXOUTCLKFABRIC_OUT          =>      GT7_TXOUTCLKFABRIC_OUT,
        GT7_TXOUTCLKPCS_OUT             =>      GT7_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT7_TXCHARISK_IN                =>      GT7_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT7_TXRESETDONE_OUT             =>      GT7_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT7_TXPRBSSEL_IN                =>      GT7_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT8  (X0Y8)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT8_DRPADDR_IN                  =>      GT8_DRPADDR_IN,
        GT8_DRPCLK_IN                   =>      GT8_DRPCLK_IN,
        GT8_DRPDI_IN                    =>      GT8_DRPDI_IN,
        GT8_DRPDO_OUT                   =>      GT8_DRPDO_OUT,
        GT8_DRPEN_IN                    =>      GT8_DRPEN_IN,
        GT8_DRPRDY_OUT                  =>      GT8_DRPRDY_OUT,
        GT8_DRPWE_IN                    =>      GT8_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT8_LOOPBACK_IN                 =>      GT8_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT8_RXUSERRDY_IN                =>      GT8_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT8_EYESCANDATAERROR_OUT        =>      GT8_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT8_RXCDRLOCK_OUT               =>      GT8_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT8_RXCLKCORCNT_OUT             =>      GT8_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT8_RXUSRCLK_IN                 =>      GT8_RXUSRCLK_IN,
        GT8_RXUSRCLK2_IN                =>      GT8_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT8_RXDATA_OUT                  =>      GT8_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT8_RXPRBSERR_OUT               =>      GT8_RXPRBSERR_OUT,
        GT8_RXPRBSSEL_IN                =>      GT8_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT8_RXPRBSCNTRESET_IN           =>      GT8_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT8_RXDISPERR_OUT               =>      GT8_RXDISPERR_OUT,
        GT8_RXNOTINTABLE_OUT            =>      GT8_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT8_GTXRXP_IN                   =>      GT8_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT8_GTXRXN_IN                   =>      GT8_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT8_RXMCOMMAALIGNEN_IN          =>      GT8_RXMCOMMAALIGNEN_IN,
        GT8_RXPCOMMAALIGNEN_IN          =>      GT8_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT8_RXDFEAGCHOLD_IN             =>      GT8_RXDFEAGCHOLD_IN,
        GT8_RXDFELPMRESET_IN            =>      GT8_RXDFELPMRESET_IN,
        GT8_RXMONITOROUT_OUT            =>      GT8_RXMONITOROUT_OUT,
        GT8_RXMONITORSEL_IN             =>      GT8_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT8_RXOUTCLK_OUT                =>      GT8_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT8_GTRXRESET_IN                =>      GT8_GTRXRESET_IN,
        GT8_RXPMARESET_IN               =>      GT8_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT8_RXCHARISCOMMA_OUT           =>      GT8_RXCHARISCOMMA_OUT,
        GT8_RXCHARISK_OUT               =>      GT8_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT8_RXRESETDONE_OUT             =>      GT8_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT8_GTTXRESET_IN                =>      GT8_GTTXRESET_IN,
        GT8_TXUSERRDY_IN                =>      GT8_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT8_TXUSRCLK_IN                 =>      GT8_TXUSRCLK_IN,
        GT8_TXUSRCLK2_IN                =>      GT8_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT8_TXDIFFCTRL_IN               =>      GT8_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT8_TXDATA_IN                   =>      GT8_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT8_GTXTXN_OUT                  =>      GT8_GTXTXN_OUT,
        GT8_GTXTXP_OUT                  =>      GT8_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT8_TXOUTCLK_OUT                =>      GT8_TXOUTCLK_OUT,
        GT8_TXOUTCLKFABRIC_OUT          =>      GT8_TXOUTCLKFABRIC_OUT,
        GT8_TXOUTCLKPCS_OUT             =>      GT8_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT8_TXCHARISK_IN                =>      GT8_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT8_TXRESETDONE_OUT             =>      GT8_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT8_TXPRBSSEL_IN                =>      GT8_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT9  (X0Y9)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT9_DRPADDR_IN                  =>      GT9_DRPADDR_IN,
        GT9_DRPCLK_IN                   =>      GT9_DRPCLK_IN,
        GT9_DRPDI_IN                    =>      GT9_DRPDI_IN,
        GT9_DRPDO_OUT                   =>      GT9_DRPDO_OUT,
        GT9_DRPEN_IN                    =>      GT9_DRPEN_IN,
        GT9_DRPRDY_OUT                  =>      GT9_DRPRDY_OUT,
        GT9_DRPWE_IN                    =>      GT9_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT9_LOOPBACK_IN                 =>      GT9_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT9_RXUSERRDY_IN                =>      GT9_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT9_EYESCANDATAERROR_OUT        =>      GT9_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT9_RXCDRLOCK_OUT               =>      GT9_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT9_RXCLKCORCNT_OUT             =>      GT9_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT9_RXUSRCLK_IN                 =>      GT9_RXUSRCLK_IN,
        GT9_RXUSRCLK2_IN                =>      GT9_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT9_RXDATA_OUT                  =>      GT9_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT9_RXPRBSERR_OUT               =>      GT9_RXPRBSERR_OUT,
        GT9_RXPRBSSEL_IN                =>      GT9_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT9_RXPRBSCNTRESET_IN           =>      GT9_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT9_RXDISPERR_OUT               =>      GT9_RXDISPERR_OUT,
        GT9_RXNOTINTABLE_OUT            =>      GT9_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT9_GTXRXP_IN                   =>      GT9_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT9_GTXRXN_IN                   =>      GT9_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT9_RXMCOMMAALIGNEN_IN          =>      GT9_RXMCOMMAALIGNEN_IN,
        GT9_RXPCOMMAALIGNEN_IN          =>      GT9_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT9_RXDFEAGCHOLD_IN             =>      GT9_RXDFEAGCHOLD_IN,
        GT9_RXDFELPMRESET_IN            =>      GT9_RXDFELPMRESET_IN,
        GT9_RXMONITOROUT_OUT            =>      GT9_RXMONITOROUT_OUT,
        GT9_RXMONITORSEL_IN             =>      GT9_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT9_RXOUTCLK_OUT                =>      GT9_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT9_GTRXRESET_IN                =>      GT9_GTRXRESET_IN,
        GT9_RXPMARESET_IN               =>      GT9_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT9_RXCHARISCOMMA_OUT           =>      GT9_RXCHARISCOMMA_OUT,
        GT9_RXCHARISK_OUT               =>      GT9_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT9_RXRESETDONE_OUT             =>      GT9_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT9_GTTXRESET_IN                =>      GT9_GTTXRESET_IN,
        GT9_TXUSERRDY_IN                =>      GT9_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT9_TXUSRCLK_IN                 =>      GT9_TXUSRCLK_IN,
        GT9_TXUSRCLK2_IN                =>      GT9_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT9_TXDIFFCTRL_IN               =>      GT9_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT9_TXDATA_IN                   =>      GT9_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT9_GTXTXN_OUT                  =>      GT9_GTXTXN_OUT,
        GT9_GTXTXP_OUT                  =>      GT9_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT9_TXOUTCLK_OUT                =>      GT9_TXOUTCLK_OUT,
        GT9_TXOUTCLKFABRIC_OUT          =>      GT9_TXOUTCLKFABRIC_OUT,
        GT9_TXOUTCLKPCS_OUT             =>      GT9_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT9_TXCHARISK_IN                =>      GT9_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT9_TXRESETDONE_OUT             =>      GT9_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT9_TXPRBSSEL_IN                =>      GT9_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT10  (X0Y10)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT10_DRPADDR_IN                 =>      GT10_DRPADDR_IN,
        GT10_DRPCLK_IN                  =>      GT10_DRPCLK_IN,
        GT10_DRPDI_IN                   =>      GT10_DRPDI_IN,
        GT10_DRPDO_OUT                  =>      GT10_DRPDO_OUT,
        GT10_DRPEN_IN                   =>      GT10_DRPEN_IN,
        GT10_DRPRDY_OUT                 =>      GT10_DRPRDY_OUT,
        GT10_DRPWE_IN                   =>      GT10_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT10_LOOPBACK_IN                =>      GT10_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT10_RXUSERRDY_IN               =>      GT10_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT10_EYESCANDATAERROR_OUT       =>      GT10_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT10_RXCDRLOCK_OUT              =>      GT10_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT10_RXCLKCORCNT_OUT            =>      GT10_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT10_RXUSRCLK_IN                =>      GT10_RXUSRCLK_IN,
        GT10_RXUSRCLK2_IN               =>      GT10_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT10_RXDATA_OUT                 =>      GT10_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT10_RXPRBSERR_OUT              =>      GT10_RXPRBSERR_OUT,
        GT10_RXPRBSSEL_IN               =>      GT10_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT10_RXPRBSCNTRESET_IN          =>      GT10_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT10_RXDISPERR_OUT              =>      GT10_RXDISPERR_OUT,
        GT10_RXNOTINTABLE_OUT           =>      GT10_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT10_GTXRXP_IN                  =>      GT10_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT10_GTXRXN_IN                  =>      GT10_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT10_RXMCOMMAALIGNEN_IN         =>      GT10_RXMCOMMAALIGNEN_IN,
        GT10_RXPCOMMAALIGNEN_IN         =>      GT10_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT10_RXDFEAGCHOLD_IN            =>      GT10_RXDFEAGCHOLD_IN,
        GT10_RXDFELPMRESET_IN           =>      GT10_RXDFELPMRESET_IN,
        GT10_RXMONITOROUT_OUT           =>      GT10_RXMONITOROUT_OUT,
        GT10_RXMONITORSEL_IN            =>      GT10_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT10_RXOUTCLK_OUT               =>      GT10_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT10_GTRXRESET_IN               =>      GT10_GTRXRESET_IN,
        GT10_RXPMARESET_IN              =>      GT10_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT10_RXCHARISCOMMA_OUT          =>      GT10_RXCHARISCOMMA_OUT,
        GT10_RXCHARISK_OUT              =>      GT10_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT10_RXRESETDONE_OUT            =>      GT10_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT10_GTTXRESET_IN               =>      GT10_GTTXRESET_IN,
        GT10_TXUSERRDY_IN               =>      GT10_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT10_TXUSRCLK_IN                =>      GT10_TXUSRCLK_IN,
        GT10_TXUSRCLK2_IN               =>      GT10_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT10_TXDIFFCTRL_IN              =>      GT10_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT10_TXDATA_IN                  =>      GT10_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT10_GTXTXN_OUT                 =>      GT10_GTXTXN_OUT,
        GT10_GTXTXP_OUT                 =>      GT10_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT10_TXOUTCLK_OUT               =>      GT10_TXOUTCLK_OUT,
        GT10_TXOUTCLKFABRIC_OUT         =>      GT10_TXOUTCLKFABRIC_OUT,
        GT10_TXOUTCLKPCS_OUT            =>      GT10_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT10_TXCHARISK_IN               =>      GT10_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT10_TXRESETDONE_OUT            =>      GT10_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT10_TXPRBSSEL_IN               =>      GT10_TXPRBSSEL_IN,

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT11  (X0Y11)
        ---------------------------- Channel - DRP Ports  --------------------------
        GT11_DRPADDR_IN                 =>      GT11_DRPADDR_IN,
        GT11_DRPCLK_IN                  =>      GT11_DRPCLK_IN,
        GT11_DRPDI_IN                   =>      GT11_DRPDI_IN,
        GT11_DRPDO_OUT                  =>      GT11_DRPDO_OUT,
        GT11_DRPEN_IN                   =>      GT11_DRPEN_IN,
        GT11_DRPRDY_OUT                 =>      GT11_DRPRDY_OUT,
        GT11_DRPWE_IN                   =>      GT11_DRPWE_IN,
        ------------------------------- Loopback Ports -----------------------------
        GT11_LOOPBACK_IN                =>      GT11_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT11_RXUSERRDY_IN               =>      GT11_RXUSERRDY_IN,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT11_EYESCANDATAERROR_OUT       =>      GT11_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT11_RXCDRLOCK_OUT              =>      GT11_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT11_RXCLKCORCNT_OUT            =>      GT11_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT11_RXUSRCLK_IN                =>      GT11_RXUSRCLK_IN,
        GT11_RXUSRCLK2_IN               =>      GT11_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT11_RXDATA_OUT                 =>      GT11_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT11_RXPRBSERR_OUT              =>      GT11_RXPRBSERR_OUT,
        GT11_RXPRBSSEL_IN               =>      GT11_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT11_RXPRBSCNTRESET_IN          =>      GT11_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT11_RXDISPERR_OUT              =>      GT11_RXDISPERR_OUT,
        GT11_RXNOTINTABLE_OUT           =>      GT11_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT11_GTXRXP_IN                  =>      GT11_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT11_GTXRXN_IN                  =>      GT11_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT11_RXMCOMMAALIGNEN_IN         =>      GT11_RXMCOMMAALIGNEN_IN,
        GT11_RXPCOMMAALIGNEN_IN         =>      GT11_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT11_RXDFEAGCHOLD_IN            =>      GT11_RXDFEAGCHOLD_IN,
        GT11_RXDFELPMRESET_IN           =>      GT11_RXDFELPMRESET_IN,
        GT11_RXMONITOROUT_OUT           =>      GT11_RXMONITOROUT_OUT,
        GT11_RXMONITORSEL_IN            =>      GT11_RXMONITORSEL_IN,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT11_RXOUTCLK_OUT               =>      GT11_RXOUTCLK_OUT,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT11_GTRXRESET_IN               =>      GT11_GTRXRESET_IN,
        GT11_RXPMARESET_IN              =>      GT11_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT11_RXCHARISCOMMA_OUT          =>      GT11_RXCHARISCOMMA_OUT,
        GT11_RXCHARISK_OUT              =>      GT11_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT11_RXRESETDONE_OUT            =>      GT11_RXRESETDONE_OUT,
        --------------------- TX Initialization and Reset Ports --------------------
        GT11_GTTXRESET_IN               =>      GT11_GTTXRESET_IN,
        GT11_TXUSERRDY_IN               =>      GT11_TXUSERRDY_IN,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT11_TXUSRCLK_IN                =>      GT11_TXUSRCLK_IN,
        GT11_TXUSRCLK2_IN               =>      GT11_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT11_TXDIFFCTRL_IN              =>      GT11_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT11_TXDATA_IN                  =>      GT11_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT11_GTXTXN_OUT                 =>      GT11_GTXTXN_OUT,
        GT11_GTXTXP_OUT                 =>      GT11_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT11_TXOUTCLK_OUT               =>      GT11_TXOUTCLK_OUT,
        GT11_TXOUTCLKFABRIC_OUT         =>      GT11_TXOUTCLKFABRIC_OUT,
        GT11_TXOUTCLKPCS_OUT            =>      GT11_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT11_TXCHARISK_IN               =>      GT11_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT11_TXRESETDONE_OUT            =>      GT11_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT11_TXPRBSSEL_IN               =>      GT11_TXPRBSSEL_IN,


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         =>      GT0_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                =>      GT0_QPLLLOCK_OUT,
        GT0_QPLLLOCKDETCLK_IN           =>      GT0_QPLLLOCKDETCLK_IN,
        GT0_QPLLREFCLKLOST_OUT          =>      GT0_QPLLREFCLKLOST_OUT,
        GT0_QPLLRESET_IN                =>      GT0_QPLLRESET_IN,

    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT1_GTREFCLK0_COMMON_IN         =>      GT1_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT1_QPLLLOCK_OUT                =>      GT1_QPLLLOCK_OUT,
        GT1_QPLLLOCKDETCLK_IN           =>      GT1_QPLLLOCKDETCLK_IN,
        GT1_QPLLREFCLKLOST_OUT          =>      GT1_QPLLREFCLKLOST_OUT,
        GT1_QPLLRESET_IN                =>      GT1_QPLLRESET_IN,

    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT2_GTREFCLK0_COMMON_IN         =>      GT2_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT2_QPLLLOCK_OUT                =>      GT2_QPLLLOCK_OUT,
        GT2_QPLLLOCKDETCLK_IN           =>      GT2_QPLLLOCKDETCLK_IN,
        GT2_QPLLREFCLKLOST_OUT          =>      GT2_QPLLREFCLKLOST_OUT,
        GT2_QPLLRESET_IN                =>      GT2_QPLLRESET_IN

    );
end RTL;     
